﻿// TODO: skew drag handles should be more distinctive


package com.ryan.geom {
	//import as3.utils.deepTrace;
	import flash.display.DisplayObject;
	import flash.display.DisplayObjectContainer;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.geom.Transform;
	import flash.ui.Mouse;
	import flash.utils.Dictionary;
	
	/*
	 * FreeTransformEvent
	 * 
	 * @author Ryan
	 * 
	 * Usage: 	var fts:FreeTransformSprite = new FreeTransformSprite(false);			
	 *			fts.registerSprite(testObj);
	 * 
	 * 			registerSprite(sourceSprite:DisplayObject):void
	 * 			Registers a mouse down listener to the DisplayObject to activate on click
	 * 
	 * 			updateAfterChange():void
	 * 			Update the handlers after the DisplayObject is modified externally
	 * 
	 * 			hideHandlers()
	 * 			hides handlers. But they will be visible again the next time the user clicks on a registered DisplayObject
	 * 
	 */
	
	public class FreeTransformManager extends Sprite {
		
		// Constants
		public const DEFAULT_MIN_SCALE:Number = 0.1;
		public const DEFAULT_MAX_SCALE:Number = 10;
		
		protected var me:FreeTransformManager;
		protected var dispObj:DisplayObject;
		protected var _boundingRect:Sprite;
		protected var _border:Sprite;
		protected var _bringTargetToTop:Boolean = true;
		protected var _configs:Dictionary;
		
		// This variable will be populated with the bounding box's
		// current transformation matrix at the beginning of any
		// reshaping operation.  It provides a stable baseline
		// (onto which user-driven changes can be layered).
		protected var _currentTransform:flash.geom.Matrix = new Matrix();
		
		// This variable will be populated with the bounding box's
		// initial shape before any reshaping has occurred.
		// It will serve as the "revert" or "undo" reference
		// point, so that the user can discard an unsatisfactory
		// transformation outcome.
		protected var _initialTransform:flash.geom.Matrix;
		protected var _cancelTransform:flash.geom.Matrix;
		
		protected var _masterOffset:flash.geom.Matrix;		
		
		protected var currConfig:Object;
		protected var stageListenersAdded:Boolean;
		protected var _enabled:Boolean;
    
		protected var _dragArea:Rectangle;
		public function get dragArea():Rectangle { return _dragArea; }
		public function set dragArea(r:Rectangle):void { _dragArea = r; }
		
		//protected  var _moveHandle:Sprite;
		protected  var _tlHandle:TransformationHandle;
		protected  var _trHandle:TransformationHandle;
		protected  var _blHandle:TransformationHandle;
		protected  var _brHandle:TransformationHandle;
		protected  var _tHandle:TransformationHandle;
		protected  var _bHandle:TransformationHandle;
		protected  var _lHandle:TransformationHandle;
		protected  var _rHandle:TransformationHandle;
		protected var _tlRotationHandle:TransformationHandle;
		protected var _trRotationHandle:TransformationHandle;
		protected var _blRotationHandle:TransformationHandle;
		protected var _brRotationHandle:TransformationHandle;
		protected var _tlSizeHandle:TransformationHandle;
		protected var _trSizeHandle:TransformationHandle;
		protected var _blSizeHandle:TransformationHandle;
		protected var _brSizeHandle:TransformationHandle;
		protected var _tSkewHandle:TransformationHandle;
		protected var _rSkewHandle:TransformationHandle;
		protected var _bSkewHandle:TransformationHandle;
		protected var _lSkewHandle:TransformationHandle;
		protected var _tScaleHandle:TransformationHandle;
		protected var _bScaleHandle:TransformationHandle;
		protected var _lScaleHandle:TransformationHandle;
		protected var _rScaleHandle:TransformationHandle;
		protected var _cRecenterHandle:TransformationHandle;
		protected var _cTranslateHandle:TransformationHandle;
		protected var _currHandle:TransformationHandle;
		
		protected  var handlerContainer:Sprite;
//		protected  var mouseAngle:Sprite;				//sprite containing the interesting stuff
//		protected  var trackPointsContainer:Sprite;
		protected  var transformContainer:Sprite;
		
//		protected var _localCenter:Point;
//		protected function get localCenter():Point {
//			return _localCenter;
//		}
		
//		protected var _storedX:Number = 0;
//		protected var _storedY:Number = 0;
//		protected var _storedRotation:Number = 0;
//		protected var _storedScale:Number = 1;
//		public var _storedScaleX:Number = 1;
//		protected var _storedScaleY:Number = 1;
//		protected var _storedC:Number = 0;
//		protected var _storedB:Number = 0;
		
		protected var mustReactivate:Boolean;
		protected var mIsDown:Boolean;
		protected var oriCP:Point;
//		protected var oriCPCircle:TrackPoint;
		protected var oriX:Number;
		protected var oriY:Number;
//		protected var oriAngle:Number;
		protected var refAngle:Number;
		protected var oriDist:Number;
		protected var dX:Number;
		protected var dY:Number;
		protected var dAngle:Number;
		protected var iMatrix:Matrix;
		
//		protected var offsetX:Number;
//		protected var offsetY:Number;
		
		protected var trackPoints:Array = [];
		protected var onSpriteFocusDict:Dictionary = new Dictionary(true);
		protected var _rotationPoint:Point;
		protected var _useSimpleHandles:Boolean = true;
		public function get UseSimpleHandles():Boolean { return _useSimpleHandles; }
		public function set UseSimpleHandles(v:Boolean):void { _useSimpleHandles = v; buildHandles(); redrawUI(); }
		protected var _showResizeHandles:Boolean = false;
		protected var _showRescaleHandles:Boolean = false;
		protected var _showRotationHandles:Boolean = false;
		protected var _showSkewHandles:Boolean = false;
		protected var _showRecenterHandle:Boolean = false;
		protected var _showTranslateHandle:Boolean = false;
		protected const _exteriorHandleOffset:Number = 40.0;
		protected const _interiorHandleOffset:Number = 40.0;
    
    // Visual style properties
		public var _handleOutlineColor:uint = 0x000000;
		public function get handleOutlineColor():uint { return _handleOutlineColor; }
		public function set handleOutlineColor(c:uint):void { _handleOutlineColor = c; redrawUI(); }
		public var _handleFillColor:uint = 0xFFFFFF;
		public function get handleFillColor():uint { return _handleFillColor; }
		public function set handleFillColor(c:uint):void { _handleFillColor = c; redrawUI(); }
		public var _boundingBoxOutlineColor:uint = 0x5555FF;
		public function get boundingBoxOutlineColor():uint { return _boundingBoxOutlineColor; }
		public function set boundingBoxOutlineColor(c:uint):void { _boundingBoxOutlineColor = c; redrawUI(); }
		
		public var _handleRadius:Number = 5;
		public function get handleRadius():Number { return _handleRadius; }
		public function set handleRadius(n:Number):void { _handleRadius = n; redrawUI(); }
		protected var _handleOutlineThickness:Number = 1;
		public function get handleOutlineThickness():Number { return _handleOutlineThickness / 2; }
		public function set handleOutlineThickness(n:Number):void { _handleOutlineThickness = n * 2; redrawUI(); }
		public var _boundingBoxOutlineThickness:Number = 2;
		public function get boundingBoxOutlineThickness():Number { return _boundingBoxOutlineThickness; }
		public function set boundingBoxOutlineThickness(n:Number):void { _boundingBoxOutlineThickness = n; redrawUI(); }
				
		public function FreeTransformManager():void {
			
			me = this;
			iMatrix = new Matrix();
			iMatrix.identity();
			enabled = true;
			
			_configs = new Dictionary(true);
			
			transformContainer = new Sprite();
			addChild(transformContainer);
			
			_boundingRect = new Sprite();
			transformContainer.addChild(_boundingRect);
			
			handlerContainer = new Sprite();
			addChild(handlerContainer);
			_border = new Sprite();
			handlerContainer.addChild(_border);
			
			buildHandles();
			
//			mouseAngle = new Sprite();
//			addChild(mouseAngle);
			
//			trackPointsContainer = new Sprite();
//			addChild(trackPointsContainer);
			
			//add some default trackpoints
//			trackPoints.push(newTrackPoint());
//			trackPoints.push(newTrackPoint());
//			trackPoints.push(newTrackPoint());
			
			me.addEventListener(MouseEvent.ROLL_OVER, onROver);
			me.addEventListener(MouseEvent.ROLL_OUT, onROut);
			_boundingRect.addEventListener(MouseEvent.MOUSE_DOWN, onDispObjMDown);
			
			mustReactivate = true;
		}
		
		public function get enabled():Boolean {
			return _enabled;
		}
		
		private var previousParent:DisplayObjectContainer;
		
		public function set enabled(v:Boolean):void {
			_enabled = v;
			if (_enabled) {
				if (previousParent){
					previousParent.addChild(me);
				}
				enableHandlers();
				showHandlers();
				if (dispObj){
					activateSprite(dispObj, this.transform.matrix, _currentTransform);
				}
				me.visible = true;
			}else {
				disableHandlers();
				hideHandlers();
				me.visible = false;
				mustReactivate = true;
				previousParent = me.parent;
				trace('Remove from parent if parent exists');
				if (previousParent) {
					trace('previousParent.numChildren='+previousParent.numChildren);
					previousParent.removeChild(me);
					trace('previousParent.removeChild');
					trace('previousParent.numChildren='+previousParent.numChildren);
				}
			}
		}
		
		/*
		 * Initializes the FreeTransformSprite
		 * 
		 * @sourceSprite : Object to be made transformable.
		 * @showInterestingStuff : Whether to show debug information
		 */ 
		
		public function registerSprite(sourceSprite:DisplayObject, config:Object = null):void {
			
			sourceSprite.addEventListener(MouseEvent.MOUSE_DOWN, _onSpriteFocus);
			onSpriteFocusDict[sourceSprite] = _onSpriteFocus;
			
			function _onSpriteFocus(evt:MouseEvent):void {
				if (me.enabled && me.dispObj == null){
					// Send out a notification
					dispatchEvent(new FreeTransformEvent(FreeTransformEvent.ON_FOCUS, evt.currentTarget as DisplayObject, null));
				}
			}
		}
		
		public function deregisterSprite(sourceSprite:DisplayObject):void {
			if (onSpriteFocusDict[sourceSprite] == undefined) {
				return;
			}
			
			if (sourceSprite == dispObj) {
				disableHandlers();
				hideHandlers();
			}
			
			sourceSprite.removeEventListener(MouseEvent.MOUSE_DOWN, onSpriteFocusDict[sourceSprite] as Function);
		}
		
		public function cancelTransformation():void {
			// Lookup the current transformation target
			if (dispObj == null) {
				// No transformation is currently underway.  Fail harmlessly (don't throw an exception).
				return;
			}
			
			// Send out a notification event for the reversion.
			dispatchEvent(new FreeTransformEvent(FreeTransformEvent.ON_CANCEL, dispObj, _cancelTransform));
			
			// Clear the transformation UI controls from the stage
			deactivateTarget();
		}
		
		public function activateSprite(sourceSprite:DisplayObject, masterOffset:flash.geom.Matrix, initialShape:flash.geom.Matrix, showRotationHandles:Boolean=true, showResizeHandles:Boolean=true, showRescaleHandles:Boolean=true, showSkewHandles:Boolean=true, showTranslationHandle:Boolean=false, showRecenterHandle:Boolean=true):void {
			trace('activateSprite');
			/* Always conform handler to target. In case target has been updated in other locations.
			if (dispObj == sourceSprite) {
				return;
			} */
			
			// Treat a null input as "identity matrix"
			masterOffset = masterOffset || new Matrix();
			initialShape = initialShape || new Matrix();
			
			// Store the master offset
			_masterOffset = masterOffset.clone();

			// Store the initial shape for safe-keeping (we may need to revert to it!)
			_cancelTransform = initialShape.clone();
			_initialTransform = masterOffset.clone();
			_initialTransform.concat(initialShape);
			_currentTransform = _initialTransform.clone();
		
			// Store the handle-visibility choices
			_showRecenterHandle = showRecenterHandle;
			_showRotationHandles = showRotationHandles;
			_showResizeHandles = showResizeHandles;
			_showSkewHandles = showSkewHandles;
			_showRescaleHandles = showRescaleHandles;
			_showTranslateHandle = showTranslationHandle;
			_showTranslateHandle = false;
			// TODO TEMP - this is a hack. The translation handle is currently superfluous and confusing, so I'm hiding it until an obvious use-case emerges.
						
			mustReactivate = false;
			
			if (_configs[sourceSprite] == undefined) {
				_configs[sourceSprite] = { };
			}
			
			currConfig = _configs[sourceSprite] as Object;
			dispObj = sourceSprite;
			
			if (dispObj.stage) {
				//oh right, got the stage
				_init();
			}else {
				//oh no, no stage. wait for added to stage
				dispObj.addEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
				function onAddedToStage(evt:Event):void {
					dispObj.removeEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
					_init();
				}
			}
			
			function _init():void {
				redrawHandles();
				conformToSprite(_initialTransform);
				//WIP: an event to alert all sprites that it is not in focus
				
				//Bring the sprite to the top
				var oriParent:DisplayObjectContainer = dispObj.parent as DisplayObjectContainer;
				if (_bringTargetToTop){
					oriParent.addChild(dispObj);
				}
				oriParent.addChild(me);
				
				handlerContainer.visible = true;
//				updateHandles();todo
				
				if (_boundingRect) { _boundingRect.visible = true; }
			
				if (!stageListenersAdded) {
					stageListenersAdded = true;
					stage.addEventListener(MouseEvent.MOUSE_MOVE, onStageMMove);
					stage.addEventListener(MouseEvent.MOUSE_UP, onStageMUp);
				}
			}
		}
		
		public function deactivateTarget():void{
			dispObj = null;
			hideHandlers();
		}
		
		public function get noActiveTarget():Boolean {
			if (dispObj == null) {
				return true;
			}
			return false;
		}
		
		protected function conformToSprite(initialShape:Matrix):void {
			
//			var tempMatrix:Matrix = dispObj.transform.matrix;
			
			trace('dispObj.x y=(' + dispObj.x + ',' + dispObj.y + ')' );
//			_storedX = dispObj.x;
//			_storedY = dispObj.y;
			//trace('dispObj.rotation=' + dispObj.rotation );
//			_storedRotation = dispObj.rotation * (Math.PI / 180);
			//trace('_storedRotation=' + _storedRotation);
			
			//dispObj.transform.matrix = iMatrix;
//			dispObj.transform.matrix = new Matrix();
			//trace('dispObj.rotation=' + dispObj.rotation);
			
			// Define new LocalCenter
			
			//Get registration point to offset the _localCenter
			var bounds:Rectangle = dispObj.getBounds(dispObj.parent);
//			var bounds:Rectangle = dispObj.getBounds(this);
			var currentRegX:Number = dispObj.x - bounds.left;
			var currentRegY:Number = dispObj.y - bounds.top;
			//trace("currConfig.reg=" + currConfig.regX + "," + currConfig.regY);
			//trace("currentReg=" + currentRegX + "," + currentRegY);

			// Draw a new bounding rect
			_boundingRect.graphics.clear();
			_boundingRect.graphics.beginFill(0xFF0000, 0.0);
			_boundingRect.graphics.drawRect(-currentRegX, -currentRegY, dispObj.width, dispObj.height);
			_boundingRect.graphics.endFill();
			_boundingRect.mouseEnabled = true;

			
			//Save registration point into config
			currConfig = _configs[dispObj] as Object;
			currConfig.regX = currentRegX;
			currConfig.regY = currentRegY;

			_configs[dispObj] = currConfig;
			
			
			// Update matrix and handles
			transformContainer.transform.matrix = initialShape;
//			transformContainer.transform.matrix = tempMatrix;
//			dispObj.transform.matrix = tempMatrix;
			updateHandles();
		}
		
		/*
		public function set minScale(n:Number):void {
			_minScale = n;
		}
		public function set maxScale(n:Number):void {
			_maxScale = n;
		}*/
		
		public function set bringTargetToTop(v:Boolean):void {
			_bringTargetToTop = v;
		}
		
		public function get bringTargetToTop():Boolean {
			return _bringTargetToTop;
		}
		
		
		
		// Handles
		protected function buildHandles():void
		{
			// Clear out any pre-existing transformation handles
			var i:int;
			for (i = handlerContainer.numChildren-1; i>0; i--) {
				if (handlerContainer.getChildAt(i) as TransformationHandle) { 
					try { _tlHandle.removeEventListener(MouseEvent.MOUSE_DOWN, onMDown); } catch (myError:Error) { }
					handlerContainer.removeChildAt(i); 
				}
			}

			// Create a new set of transformation handles based on configuration parameters
			var rotateAndSizeMode:uint;
			rotateAndSizeMode = (1 << TransformationHandle.MODE_ROTATE) | (1 << TransformationHandle.MODE_RESIZE);
			_tlHandle = new TransformationHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius, rotateAndSizeMode);
			_trHandle = new TransformationHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius, rotateAndSizeMode);
			_blHandle = new TransformationHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius, rotateAndSizeMode);
			_brHandle = new TransformationHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius, rotateAndSizeMode);
			var scaleAndSkewVerticalMode:uint;
			scaleAndSkewVerticalMode = (1 << TransformationHandle.MODE_SCALE_VERTICAL) | (1 << TransformationHandle.MODE_SKEW_VERTICAL);
			var scaleAndSkewHorizontalMode:uint;
			scaleAndSkewHorizontalMode = (1 << TransformationHandle.MODE_SCALE_HORIZONTAL) | (1 << TransformationHandle.MODE_SKEW_HORIZONTAL);
			_tHandle = new TransformationHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius, scaleAndSkewVerticalMode);
			_bHandle = new TransformationHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius, scaleAndSkewVerticalMode);
			_lHandle = new TransformationHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius, scaleAndSkewHorizontalMode);
			_rHandle = new TransformationHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius, scaleAndSkewHorizontalMode);
			_tlSizeHandle = new ResizeHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius);
			_trSizeHandle = new ResizeHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius);
			_blSizeHandle = new ResizeHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius);
			_brSizeHandle = new ResizeHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius);
			_tlRotationHandle = new RotateHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius);
			_trRotationHandle = new RotateHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius);
			_blRotationHandle = new RotateHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius);
			_brRotationHandle = new RotateHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius);
			_tScaleHandle = new RescaleHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius, false);
			_bScaleHandle = new RescaleHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius, false);
			_lScaleHandle = new RescaleHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius, true);
			_rScaleHandle = new RescaleHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius, true);
			_tSkewHandle = new SkewHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius, false);
			_bSkewHandle = new SkewHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius, false);
			_lSkewHandle = new SkewHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius, true);
			_rSkewHandle = new SkewHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius, true);
			_cRecenterHandle = new RecenterHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius);
			_cTranslateHandle = new TranslateHandle(_handleOutlineColor, _handleOutlineThickness, _handleFillColor, _handleRadius);
			redrawHandles();
			
			// Add the new handles to the collection
			handlerContainer.addChild(_tlHandle);
			handlerContainer.addChild(_trHandle);
			handlerContainer.addChild(_brHandle);
			handlerContainer.addChild(_blHandle);
			handlerContainer.addChild(_tHandle);
			handlerContainer.addChild(_bHandle);
			handlerContainer.addChild(_rHandle);
			handlerContainer.addChild(_lHandle);
			handlerContainer.addChild(_tlSizeHandle);
			handlerContainer.addChild(_trSizeHandle);
			handlerContainer.addChild(_brSizeHandle);
			handlerContainer.addChild(_blSizeHandle);
			handlerContainer.addChild(_tlRotationHandle);
			handlerContainer.addChild(_trRotationHandle);
			handlerContainer.addChild(_brRotationHandle);
			handlerContainer.addChild(_blRotationHandle);
			handlerContainer.addChild(_tScaleHandle);
			handlerContainer.addChild(_bScaleHandle);
			handlerContainer.addChild(_rScaleHandle);
			handlerContainer.addChild(_lScaleHandle);
			handlerContainer.addChild(_tSkewHandle);
			handlerContainer.addChild(_bSkewHandle);
			handlerContainer.addChild(_rSkewHandle);
			handlerContainer.addChild(_lSkewHandle);
			handlerContainer.addChild(_cRecenterHandle);
			handlerContainer.addChild(_cTranslateHandle);

			// Listen for events on the new handle objects
			_tlHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			_trHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			_brHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			_blHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			_tHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			_bHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			_rHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			_lHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			_tlRotationHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			_trRotationHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			_brRotationHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			_blRotationHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			_tlSizeHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			_trSizeHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			_brSizeHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			_blSizeHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			_tSkewHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			_bSkewHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			_rSkewHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			_lSkewHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			_tScaleHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			_bScaleHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			_rScaleHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			_lScaleHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			_cRecenterHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
			_cTranslateHandle.addEventListener(MouseEvent.MOUSE_DOWN, onMDown);
		}
		
		protected function redrawHandles():void {
			// Clear all known handles
			var i:int = 0;
			for (i=0; i < handlerContainer.numChildren; i++)
			{
				if ((handlerContainer.getChildAt(i) as TransformationHandle) == null) { continue; }	// Ignore non-handle children (e.g. border sprite)
				(handlerContainer.getChildAt(i) as TransformationHandle).graphics.clear();
			}
			
			// Draw the appropriate set of handles (based on state/context/config)
			_cRecenterHandle.DrawHandle();
			_cRecenterHandle.alpha = _showRecenterHandle ? 1.0 : 0.2;
			_cRecenterHandle.visible = _cRecenterHandle.mouseEnabled = _showRecenterHandle;
			
			if (_showTranslateHandle) { _cTranslateHandle.DrawHandle(); }

			if (_useSimpleHandles) {
				_tlHandle.DrawHandle();
				_trHandle.DrawHandle();
				_blHandle.DrawHandle();
				_brHandle.DrawHandle();
				_tHandle.DrawHandle();
				_bHandle.DrawHandle();
				_lHandle.DrawHandle();
				_rHandle.DrawHandle();
				return;
			}

			if (_showSkewHandles) {
				_tSkewHandle.DrawHandle();
				_bSkewHandle.DrawHandle();
				_lSkewHandle.DrawHandle();
				_rSkewHandle.DrawHandle();
			}
			if (_showRotationHandles) {
				_tlRotationHandle.DrawHandle();
				_trRotationHandle.DrawHandle();
				_blRotationHandle.DrawHandle();
				_brRotationHandle.DrawHandle();
			}
			if (_showResizeHandles) {
				_tlSizeHandle.DrawHandle();
				_trSizeHandle.DrawHandle();
				_blSizeHandle.DrawHandle();
				_brSizeHandle.DrawHandle();
			}
			if (_showRescaleHandles) {
				_tScaleHandle.DrawHandle();
				_bScaleHandle.DrawHandle();
				_lScaleHandle.DrawHandle();
				_rScaleHandle.DrawHandle();
			}
		}
		
		protected function redrawUI():void {
			redrawHandles();
			updateHandles();
		}
		
		protected function updateHandles():void
		{
			var tempPoint:Point;
			var exteriorPoint:Point;

			var objWidth:Number = 1.0;
			var objHeight:Number = 1.0;
			if (!dispObj) { return; }			// We can't do anything useful if we lack a focus object
				
			var regX:Number = 0;
		    var regY:Number = 0;
			currConfig = _configs[dispObj] as Object;
			regX = currConfig.regX;
			regY = currConfig.regY;
				
			objWidth = dispObj.width; objHeight = dispObj.height;
			_border.graphics.clear();
			_border.graphics.lineStyle(boundingBoxOutlineThickness, boundingBoxOutlineColor, 1, true);
			
//			if (!_rotationPoint) { try { _rotationPoint = getRelativeCenterPoint(); } catch (myError:Error) { } }	// Initialize the transformation axis
			// center
			tempPoint = me.globalToLocal(transformContainer.localToGlobal(new Point(objWidth/2, objHeight/2)));
			_cTranslateHandle.x = tempPoint.x; _cTranslateHandle.y = tempPoint.y;
			_cTranslateHandle.rotation = transformContainer.rotation;
			if (_rotationPoint) { _cRecenterHandle.x = _rotationPoint.x; _cRecenterHandle.y = _rotationPoint.y; }

			//top left
			//tempPoint = me.globalToLocal(transformContainer.localToGlobal(new Point(0, 0)));
			tempPoint = me.globalToLocal(transformContainer.localToGlobal(new Point(-regX, -regY)));
			_tlHandle.x = _tlSizeHandle.x = tempPoint.x;
			_tlHandle.y = _tlSizeHandle.y = tempPoint.y;
			_tlSizeHandle.rotation = transformContainer.rotation + 180;
//			_tlHandler.rotation = _storedRotation / (Math.PI / 180);
			_border.graphics.moveTo(tempPoint.x, tempPoint.y);
			exteriorPoint = me.globalToLocal(transformContainer.localToGlobal(new Point(-regX + _interiorHandleOffset, -regY)));
			_tlRotationHandle.x = exteriorPoint.x; _tlRotationHandle.y = exteriorPoint.y;

			//top
			tempPoint = me.globalToLocal(transformContainer.localToGlobal(new Point(objWidth/2-regX, -regY)));
			_tHandle.x = _tSkewHandle.x = tempPoint.x;
			_tHandle.y = _tSkewHandle.y = tempPoint.y;
			_tSkewHandle.rotation = transformContainer.rotation + Math.PI / 2;
//			_tHandler.rotation = _storedRotation / (Math.PI / 180);
			_border.graphics.lineTo(tempPoint.x, tempPoint.y);
			exteriorPoint = me.globalToLocal(transformContainer.localToGlobal(new Point(objWidth/2-regX, -regY - _exteriorHandleOffset)));
			_tScaleHandle.x = exteriorPoint.x; _tScaleHandle.y = exteriorPoint.y;
			_tScaleHandle.rotation = 180 + transformContainer.rotation;
			
			//top right
			//tempPoint = me.globalToLocal(transformContainer.localToGlobal(new Point(_boundingRect.width, 0)));
			tempPoint = me.globalToLocal(transformContainer.localToGlobal(new Point(objWidth-regX,-regY)));
			_trHandle.x = _trSizeHandle.x = tempPoint.x;
			_trHandle.y = _trSizeHandle.y = tempPoint.y;
			_trSizeHandle.rotation = transformContainer.rotation + 270;
//			_trHandler.rotation = _storedRotation / (Math.PI / 180);
			_border.graphics.lineTo(tempPoint.x, tempPoint.y);
			exteriorPoint = me.globalToLocal(transformContainer.localToGlobal(new Point(objWidth - regX - _interiorHandleOffset,-regY)));
			_trRotationHandle.x = exteriorPoint.x; _trRotationHandle.y = exteriorPoint.y;
			
			//right
			tempPoint = me.globalToLocal(transformContainer.localToGlobal(new Point(objWidth-regX,objHeight/2-regY)));
			_rHandle.x = _rSkewHandle.x = tempPoint.x;
			_rHandle.y = _rSkewHandle.y = tempPoint.y;
			_rSkewHandle.rotation = transformContainer.rotation;
//			_rHandler.rotation = _storedRotation / (Math.PI / 180);
			_border.graphics.lineTo(tempPoint.x, tempPoint.y);			
			exteriorPoint = me.globalToLocal(transformContainer.localToGlobal(new Point(objWidth-regX + _exteriorHandleOffset,objHeight/2-regY)));
			_rScaleHandle.x = exteriorPoint.x; _rScaleHandle.y = exteriorPoint.y;
			_rScaleHandle.rotation = 270 + transformContainer.rotation;

			//bottom right
			//tempPoint = me.globalToLocal(transformContainer.localToGlobal(new Point(_boundingRect.width, _boundingRect.height)));
			tempPoint = me.globalToLocal(transformContainer.localToGlobal(new Point(objWidth-regX,objHeight-regY)));
			_brHandle.x = _brSizeHandle.x = tempPoint.x;
			_brHandle.y = _brSizeHandle.y = tempPoint.y;
			_brSizeHandle.rotation = transformContainer.rotation;
//			_brHandler.rotation = _storedRotation / (Math.PI / 180);
			_border.graphics.lineTo(tempPoint.x, tempPoint.y);
			exteriorPoint = me.globalToLocal(transformContainer.localToGlobal(new Point(objWidth - regX - _interiorHandleOffset,objHeight-regY)));
			_brRotationHandle.x = exteriorPoint.x; _brRotationHandle.y = exteriorPoint.y;
			
			//bottom
			tempPoint = me.globalToLocal(transformContainer.localToGlobal(new Point(objWidth/2-regX,objHeight-regY)));
			_bHandle.x = _bSkewHandle.x = tempPoint.x;
			_bHandle.y = _bSkewHandle.y = tempPoint.y;
			_bSkewHandle.rotation = transformContainer.rotation + Math.PI / 2;
//			_bHandler.rotation = _storedRotation / (Math.PI / 180);
			_border.graphics.lineTo(tempPoint.x, tempPoint.y);			
			exteriorPoint = me.globalToLocal(transformContainer.localToGlobal(new Point(objWidth/2-regX,objHeight-regY + _exteriorHandleOffset)));
			_bScaleHandle.x = exteriorPoint.x; _bScaleHandle.y = exteriorPoint.y;
			_bScaleHandle.rotation = transformContainer.rotation
			
			//bottom left
			//tempPoint = me.globalToLocal(transformContainer.localToGlobal(new Point(0, _boundingRect.height)));
			tempPoint = me.globalToLocal(transformContainer.localToGlobal(new Point(-regX, objHeight-regY)));
			_blHandle.x = _blSizeHandle.x = tempPoint.x;
			_blHandle.y = _blSizeHandle.y = tempPoint.y;
			_blSizeHandle.rotation = transformContainer.rotation + 90;
//			_blHandler.rotation = _storedRotation / (Math.PI / 180);
			_border.graphics.lineTo(tempPoint.x, tempPoint.y);
			exteriorPoint = me.globalToLocal(transformContainer.localToGlobal(new Point(- regX + _interiorHandleOffset, objHeight-regY)));
			_blRotationHandle.x = exteriorPoint.x; _blRotationHandle.y = exteriorPoint.y;
			
			//left
			tempPoint = me.globalToLocal(transformContainer.localToGlobal(new Point(-regX, objHeight/2-regY)));
			_lHandle.x = _lSkewHandle.x = tempPoint.x;
			_lHandle.y = _lSkewHandle.y = tempPoint.y;
			_lSkewHandle.rotation = transformContainer.rotation;
//			_lHandler.rotation = _storedRotation / (Math.PI / 180);
			_border.graphics.lineTo(tempPoint.x, tempPoint.y);
			exteriorPoint = me.globalToLocal(transformContainer.localToGlobal(new Point(-regX - _exteriorHandleOffset, objHeight/2-regY)));
			_lScaleHandle.x = exteriorPoint.x; _lScaleHandle.y = exteriorPoint.y;
			_lScaleHandle.rotation = 90 + transformContainer.rotation;
			
			//top left to close the loop
			//tempPoint = me.globalToLocal(transformContainer.localToGlobal(new Point(0, 0)));
			tempPoint = me.globalToLocal(transformContainer.localToGlobal(new Point(-regX,-regY)));
			_border.graphics.lineTo(tempPoint.x, tempPoint.y);
		}
		
		public function hideHandlers():void {
			handlerContainer.visible = false;
			if (_boundingRect) { _boundingRect.visible = false; }
			 mustReactivate = true;
		}
		
		public function showHandlers():void {
			if (handlerContainer){
				handlerContainer.visible = true;
			}
			if (_boundingRect) { _boundingRect.visible = true; }
		}
		
		public function disableHandlers():void {
			handlerContainer.mouseEnabled = false;
			_boundingRect.mouseEnabled = false;
		}
		
		public function enableHandlers():void {
			if (handlerContainer){
				handlerContainer.mouseEnabled = true;
			}
			if (_boundingRect){
				_boundingRect.mouseEnabled = true;
			}
		}
		
		
		// Move 
		protected function onDispObjMDown(evt:MouseEvent):void {
			//trace('_enabled=' + _enabled);
			trace('mustReactivate=' + mustReactivate);
			
			mIsDown = true;
			// Pretend that the user clicked on the translation handle (for the sake of followup logic on MMove and MUp)
			_currHandle = _cTranslateHandle;
			
//			oriX = stage.mouseX;
//			oriY = stage.mouseY;
			_currentTransform = transformContainer.transform.matrix.clone();
			oriX = parent.mouseX;
			oriY = parent.mouseY;
//			offsetX = _storedX;
//			offsetY = _storedY;
//			oriCP = getRelativeCenterPoint();
//			(trackPoints[2] as TrackPoint).update('oriCP', oriCP);
		}
		
		protected function onROver(evt:MouseEvent):void {
			//handlerContainer.visible = true;
			handlerContainer.alpha = 1;
			transformContainer.alpha = 1;
		}
		
		protected function onROut(evt:MouseEvent):void {
			//handlerContainer.visible = false;
			handlerContainer.alpha = 0.5;
			transformContainer.alpha = 0;
		}
		
		protected function onMDown(evt:MouseEvent):void {
			mIsDown = true;
			
			//oriX = stage.mouseX;
			//oriY = stage.mouseY;
			//oriX = me.mouseX;
			//oriY = me.mouseY;
			
			_currentTransform = transformContainer.transform.matrix.clone();
			
			_currHandle = evt.target as TransformationHandle;
			
			var handlerCenter:Point = me.globalToLocal(_currHandle.localToGlobal(new Point(0, 0)));
			oriX = handlerCenter.x;
			oriY = handlerCenter.y;
			
			oriCP = getRelativeCenterPoint();
			// Ensure that the rotation point is non-null
			if (!_rotationPoint) { _rotationPoint = oriCP; }
//			this.graphics.clear();
//			this.graphics.beginFill(0x00FF00, 1.0);
//			this.graphics.moveTo(oriCP.x, oriCP.y);
//			this.graphics.drawCircle(oriCP.x, oriCP.y, 3);
//			this.graphics.lineTo(oriCP.x + 1, oriCP.y);
//			this.graphics.endFill();
//			(trackPoints[2] as TrackPoint).update('oriCP', oriCP);
			
			//oriAngle = Math.atan((oriY - oriCP.y) / (oriX - oriCP.x));
//			oriAngle = _storedRotation;
			refAngle = getAngleFromMouseCoord(oriX, oriY, oriCP);
			oriDist = Math.sqrt(Math.pow(oriX - oriCP.x, 2) + Math.pow(oriY - oriCP.y, 2));
//			oriScaleX = _storedScaleX;
//			oriScaleY = _storedScaleY;
//			oriC = _storedC;
//			oriB = _storedB;
			//trace('oriAngle=' + oriAngle);
			
			//trace('oriCP: (' + oriCP.x + ',' + oriCP.y + ')');
		}
		
		protected function onStageMMove(evt:MouseEvent):void {
			if (!_enabled || !mIsDown) return;
			var currX:Number;
			var currY:Number;
				
			if (_currHandle.OperationMode_Translate) {
				//moving
				currX = parent.mouseX;
				currY = parent.mouseY;
				dX = currX - oriX;
				dY = currY - oriY;
				doTranslate(dX, dY);
			} else if  (_currHandle.OperationMode_Recenter) {
				// redefining the axis/center of transformation
				_rotationPoint = new Point(parent.mouseX, parent.mouseY);
				updateHandles();
			} else {
				// We're performing an axis-sensitive operation.  Compute the angles.
				currX = me.mouseX;
				currY = me.mouseY;
				var currAngle:Number = getAngleFromMouseCoord(currX, currY, oriCP);
				dAngle = currAngle - refAngle; //trace('dAngle=' + dAngle);
				var newDist:Number = Math.sqrt(Math.pow(currX - oriCP.x, 2) + Math.pow(currY - oriCP.y, 2));
				var percentage:Number = newDist / oriDist;
				
				// Ensure that the transformation point is visible
				_cRecenterHandle.visible = true;
				
				// Constrain Transform by limits
				percentage = Math.min(maxScale, Math.max(minScale, percentage));

				// Assemble the change(s) into a matrix
				var adjustmentMatrix:Matrix = new Matrix();
				if (_currHandle.OperationMode_Resize) {
					adjustmentMatrix.concat(new Matrix(percentage, 0, 0, percentage, 0, 0));
				} if (_currHandle.OperationMode_Rotate) {
					adjustmentMatrix.rotate(dAngle);
				} if (_currHandle.OperationMode_Skew_Vertical) {
					adjustmentMatrix.concat(new Matrix(1, 0, -Math.sin(dAngle), 1, 0, 0));
				} if (_currHandle.OperationMode_Scale_Vertical) {
					adjustmentMatrix.concat(new Matrix(1, 0, 0, percentage, 0, 0));
				} if (_currHandle.OperationMode_Skew_Horizontal) {
					adjustmentMatrix.concat(new Matrix(1, Math.sin(dAngle), 0, 1, 0, 0));
				} if (_currHandle.OperationMode_Scale_Horizontal) {
					adjustmentMatrix.concat(new Matrix(percentage, 0, 0, 1, 0, 0));
				}
				
				// We can't immediately apply the new adjustment; we need to recenter first
				var transformMatrix:Matrix = _currentTransform.clone();
				transformMatrix.translate(_rotationPoint.x * -1, _rotationPoint.y * -1);		// Move the bounding box so that it is concentric with the desired axis point
				transformMatrix.concat(adjustmentMatrix);										// Perform the rotation/skew/scale
				transformMatrix.translate(_rotationPoint.x, _rotationPoint.y);					// Undo the previous movement; translate the box back into its appropriate position
				transformContainer.transform.matrix = transformMatrix;
				
				// Notify listeners about the transformation
				var effectiveTransform:Matrix = _masterOffset.clone();
				effectiveTransform.invert();
				effectiveTransform.concat(transformContainer.transform.matrix);
				dispatchEvent(new FreeTransformEvent(FreeTransformEvent.ON_TRANSFORM, dispObj, effectiveTransform));
				
				// Redraw the bounding rectangle and resize handles
				conformToSprite(transformMatrix);
			}
		}
		
		/*
		 * Returns the bearing of the mouse relative to @center
		 * 
		 */
		//private var prevQuad:int;
		protected function getAngleFromMouseCoord(mx:Number, my:Number, center:Point):Number {
			
			var relX:Number = mx - center.x;
			var relY:Number = my - center.y;
			var angle:Number;
			var quad:int; //0: top left, 1:top right, 2:bottom right, 3:bottom left
			
			//flip Y
			relY = -relY;
			//trace('currConfig:'); deepTrace(currConfig);
			if (relX == 0 || relY == 0) {			
				if (currConfig.prevQuad != undefined) {
					quad = currConfig.prevQuad;
				}else {
					quad = 0; //default to first quadrant
				}
			}
			
			if (relX > 0 && relY > 0) {
				quad = 0;
			}else if (relX > 0 && relY < 0) {
				quad = 1;
			}else if (relX < 0 && relY < 0) {
				quad = 2;
			}else if (relX < 0 && relY > 0) {
				quad = 3;
			}
			
			currConfig.prevQuad = quad;
			
			relX = Math.abs(relX);
			relY = Math.abs(relY);
			
			angle = Math.atan(relY / relX);
			switch(quad) {
				case 0:
					angle = (Math.PI / 2) - angle;
					break;
				case 1:
					angle = angle + (Math.PI / 2);
					break;
				case 2:
					angle = (Math.PI / 2) - angle + Math.PI;
					break;
				case 3:
					angle = angle + (3 * Math.PI / 2);
					break;
			}
			//trace('relX=' + relX + ', relY=' + relY + ', quad=' +quad + ', angle=' + angle);
			//trace('relX=' + relX + ', relY=' + relY + ', quad=' +quad + ', angle=' + (angle / (Math.PI / 180)));
			
			/*
			//constrain to -180 to 180
			if (angle < -Math.PI) {
				angle = (2 * Math.PI) - angle;
			}else if(angle > Math.PI) {
				angle = angle - (2 * Math.PI);
			}
			*/
			//TestFTM.instance.txtQuad.text = quad.toFixed(0);
			//TestFTM.instance.txtDAngle.text = (angle / (Math.PI / 180)).toFixed(2);
			
			return angle;
		}
		
		protected function onStageMUp(evt:MouseEvent):void {
			mIsDown = false;
			
			// Ensure that the rotation point is non-null
			if (!_rotationPoint) { _rotationPoint = oriCP; }
			else if (_currHandle == _cTranslateHandle) {
				// After a translation, we must update the centerpoint
				_rotationPoint.x += parent.mouseX - oriX;
				_rotationPoint.y += parent.mouseY - oriY;
				updateHandles();
			}
			
			_cRecenterHandle.visible = _showRecenterHandle;
			
			_currentTransform = transformContainer.transform.matrix.clone();
		}
		
		protected function doTranslate(dX:Number, dY:Number):void {
			//trace('doTranslate()');
			if (!_enabled) return;

			var newX:Number = dX;
			var newY:Number = dY;
			
			// Constrain Transform by dragArea
			if (dragArea){
				newX = Math.min(dragArea.right, Math.max(dragArea.left, newX));
				newY = Math.min(dragArea.bottom, Math.max(dragArea.top, newY));
			}
			var translatedMatrix:Matrix = _currentTransform.clone();
			translatedMatrix.concat(new Matrix(1, 0, 0, 1, newX, newY));
//			_currentTransform.concat(new Matrix(1, 0, 0, 1, newX, newY));
			//_currentTransform.tx = newX;
			//_currentTransform.ty = newY;
			//transformContainer.transform.matrix = _currentTransform;
//			transformContainer.transform.matrix.tx = newX;
//			transformContainer.transform.matrix.ty = newY;
			transformContainer.transform.matrix = translatedMatrix;
			updateHandles();
			
			//_rotationPoint = _rotationPoint.add(new Point(dX, dY));
//			_rotationPoint.x += dX; _rotationPoint.y += dY;
			
			var effectiveTransform:Matrix = _masterOffset.clone();
			effectiveTransform.invert();
			effectiveTransform.concat(transformContainer.transform.matrix);
			dispatchEvent(new FreeTransformEvent(FreeTransformEvent.ON_TRANSFORM, dispObj, effectiveTransform));
		}
		
		
		/*
		 * onTransform - Roates and scales the object
		 * @angle: angle in radians
		 * @scale: percentage of original size (relative to on mouse down)
		 */
/*		protected function doTransform(angle:Number, scale:Number) {
			//trace('doTransform()');
			if (!_enabled) return;
			
		}*/
	
/*
		// TODO: should these functions perform a proportionate xy adjustment instead of independent (distorting) adjustments?
		public function setWidth(w:Number):void {
			setScaleX(w / _boundingRect.width);
		}
		
		public function setHeight(h:Number):void {
			setScaleY(h / _boundingRect.height);
		}
		
		public function setSize(w:Number, h:Number):void {
			setWidth(w);
			setHeight(h);
		}*/
/*		
		//Set rotation in degrees
		public function setRotateDeg(r:Number):void {
			setRotate(r * Math.PI / 180);
		}
		
		private function get canTransform():Boolean {
			if (!_enabled) return false;
			if (noActiveTarget) return false;
			
			return true;
		}
		
		public function setScaleX(s:Number):void {
			_boundingRect.transform.matrix.concat(new Matrix(s, 0, 0, 1, 0, 0));
		}
		
		public function setScaleY(s:Number):void {
			if (!canTransform) return;
			oriCP = getRelativeCenterPoint();
			_storedScaleY = s;
			_applyStoredProperties();
		}
		
		public function setRotate(r:Number):void {
			if (!canTransform) return;
			oriCP = getRelativeCenterPoint();
			_storedRotation = r;
			_applyStoredProperties();
		}*/
		/*
		//Not heavily tested yet
		public function setPos(x:Number, y:Number):void {
			//trace('setPos');
			if (!canTransform) return;
      
			var matrix:Matrix = dispObj.transform.matrix;
			offsetX = matrix.tx;
			offsetY = matrix.ty;
			
			doTranslate(x - offsetX, y - offsetY);
		}
		
		protected function _applyStoredProperties():void {
			// Constrain to -180 to 180
			_storedRotation = (_storedRotation + Math.PI) % (2 * Math.PI) - Math.PI;
			// Constrain Scale by config
			_storedScaleX = Math.min(maxScale, Math.max(minScale, _storedScaleX));
			_storedScaleY = Math.min(maxScale, Math.max(minScale, _storedScaleY));
			var matrix:Matrix = new Matrix();
			matrix.scale(_storedScaleX, _storedScaleY);
			matrix.c = _storedC;
			matrix.b = _storedB;
			matrix.rotate(_storedRotation);
			
			if (oriCP != null) {
				var transedP:Point = matrix.transformPoint(localCenter);
				(trackPoints[0] as TrackPoint).update('transedP', transedP);
				matrix.translate(-transedP.x, -transedP.y);
				// return to original postion
				matrix.translate(oriCP.x, oriCP.y);
	//			// update stored x n y
	//			_storedX = matrix.tx;
	//			_storedY = matrix.ty;
			}
			dispObj.transform.matrix = matrix;
			transformContainer.transform.matrix = matrix;
			updateHandles();
			dispatchEvent(new FreeTransformEvent(FreeTransformEvent.ON_TRANSFORM, dispObj, _boundingRect.transform.matrix));
		}
		
		
		// ?? Can't remember why this function is here lol
		public function setObjectSize(obj:DisplayObject, w:Number):void {
			
		}*/
    /*
    public function updateForDragArea():void{
      //TODO: Update so that dragArea is respected
      
    }*/
    
    
    
    
		
		
		
		
		// Config accessors
		public function get minScale():Number {
			
			if (currConfig) {
				if (currConfig.minScale != undefined) {
					return currConfig.minScale;
				}else {
					//TODO: if scale is not set, check W/H settings
					if (currConfig.minW != undefined && currConfig.minH != undefined) {
						return Math.min(currConfig.minW / dispObj.width, currConfig.minH / dispObj.height);
					}else if (currConfig.minW != undefined) {
						return currConfig.minW / dispObj.width;
					}else if (currConfig.minH != undefined) {
						return currConfig.minH / dispObj.height;
					}
				}
			}
			return DEFAULT_MIN_SCALE;
		}
		
		public function get maxScale():Number {
			
			if (currConfig) {
				if (currConfig.maxScale != undefined) {
					return currConfig.maxScale;
				}else {
					//TODO: if scale is not set, check W/H settings
					if (currConfig.maxW != undefined && currConfig.maxH != undefined) {
						return Math.max(currConfig.maxW / dispObj.width, currConfig.maxH / dispObj.height);
					}else if (currConfig.maxW != undefined) {
						return currConfig.maxW / dispObj.width;
					}else if (currConfig.maxH != undefined) {
						return currConfig.maxH / dispObj.height;
					}
				}
			}
			return DEFAULT_MAX_SCALE;
		}
		
		
		// Helpers
		
		protected function getRelativeCenterPoint():Point {
			// Using localToGlobal/globalToLocal is less precise than doing it mathematically, but the end result is more accurate inside Flash because it's in sync with Flash's positioning and rotating limitations
//			var localCenter = new Point(_boundingRect.x + _boundingRect.width / 2, _boundingRect.y + _boundingRect.height / 2);
//			var localCenter = new Point(_boundingRect.width / 2, _boundingRect.height / 2);
			//var localCenter = new Point(dispObj.x + dispObj.width / 2, dispObj.y + dispObj.height / 2);
//			var localCenter = new Point(dispObj.width / 2, dispObj.height / 2);
//			return me.globalToLocal(dispObj.localToGlobal(localCenter));
	//		var localCenter = new Point(0, 0);
	//		return this.globalToLocal(dispObj.localToGlobal(localCenter));
			
			
			var bounds:Rectangle = dispObj.getBounds(dispObj.parent);
			var objCenterPoint:Point = new Point(bounds.left + dispObj.width / 2, bounds.top + dispObj.height / 2);
			
			return this.globalToLocal(dispObj.parent.localToGlobal(objCenterPoint));
		}
		
		/*
		protected function clear():void {
			//trace('clear()');
			mouseAngle.graphics.clear();
		}*/
		
		/*
		protected function drawLine(x1:Number, y1:Number, x2:Number, y2:Number, color:uint):void {
			//trace('drawLine(' + x1 + ',' + y1 + ',' + x2 + ',' + y2 + ')');
			mouseAngle.graphics.lineStyle(3, color, 0.6, true);
			mouseAngle.graphics.moveTo(x1, y1);
			mouseAngle.graphics.lineTo(x2, y2);
		}*/
		
/*		protected function newTrackPoint(label:String = '', point:Point = null): TrackPoint {
			var tempTP:TrackPoint = new TrackPoint(label, point);
			trackPointsContainer.addChild(tempTP);
			return tempTP;
		}*/
		
		
		
		// Accessor functions
		
		public function getDispObj():DisplayObject{
			return dispObj;
		}
	}		// end class definition
}			// end package definition