﻿package com.ryan.geom {
	import flash.display.Sprite;
	import flash.display.Graphics;
	
	public class RecenterHandle extends TransformationHandle
	{
		public function RecenterHandle(lineColor:uint, lineThickness:Number, fillColor:uint, handleSize:Number, usehandCursor:Boolean=true)
		{
			var mode:uint = 1;
			mode <<= MODE_RECENTER;
			super(lineColor, lineThickness, fillColor, handleSize, mode, usehandCursor);
		}
		
		override public function DrawHandle():void 
		{
			// Draw the shape (gradient-filled circle)
			graphics.clear();
			graphics.beginGradientFill("radial", [_fillColor, _fillColor], [1.0, 0.0], [0, 255]);
			graphics.drawCircle(0, 0, _handleSize);
			graphics.endFill();
			// Draw the "bullseye" rings
			graphics.beginFill(_lineColor, 1.0);
			graphics.drawCircle(0, 0, _handleSize + _lineThickness);
			graphics.drawCircle(0, 0, 5);
			graphics.endFill();
		}
	}			// end class definition
}				// end package definition