﻿package com.ryan.geom {
	import flash.display.Sprite;
	import flash.display.Graphics;
	import flash.geom.Matrix;
	
	public class RescaleHandle extends TransformationHandle
	{
		public function RescaleHandle(lineColor:uint, lineThickness:Number, fillColor:uint, handleSize:Number, operationModeHorizontal:Boolean, usehandCursor:Boolean=true)
		{
			var mode:uint = 1;
			mode <<= (operationModeHorizontal ? MODE_SCALE_HORIZONTAL : MODE_SCALE_VERTICAL);
			super(lineColor, lineThickness, fillColor, handleSize, mode, usehandCursor);
		}
		
		override public function DrawHandle():void 
		{
			// Draw the basic shape (rectangle)
			graphics.clear();
			graphics.beginFill(_lineColor, 1.0);
			graphics.drawRect(_handleSize * -1, _handleSize * -1, _handleSize * 2, _handleSize * 2);
			graphics.beginFill(_fillColor, 1.0);
			graphics.drawRect((-1 * _handleSize) + _lineThickness, (-1 * _handleSize) + _lineThickness, (2 * _handleSize) - (2 * _lineThickness), (2 * _handleSize) - (2 * _lineThickness));
			graphics.endFill();
			
			// Draw the arrow
			graphics.lineStyle(_lineThickness/2, _lineColor);
			graphics.moveTo(0, _handleSize * 1.25);
			graphics.lineTo(0, _handleSize * 2);
			graphics.lineTo(_handleSize * -0.375, _handleSize * 1.5);
			graphics.moveTo(0, _handleSize * 2);
			graphics.lineTo(_handleSize * 0.375, _handleSize * 1.5);
		}
	}			// end class definition
}				// end package definition