﻿package com.ryan.geom {
	import flash.display.Sprite;
	import flash.display.Graphics;
	import flash.geom.Matrix;
	
	public class ResizeHandle extends TransformationHandle
	{
		public function ResizeHandle(lineColor:uint, lineThickness:Number, fillColor:uint, handleSize:Number, usehandCursor:Boolean=true)
		{
			var mode:uint=1;
			mode <<= MODE_RESIZE;
			super(lineColor, lineThickness, fillColor, handleSize, mode, usehandCursor);
		}
		
		override public function DrawHandle():void 
		{
			// Draw the basic shape (rectangle)
			graphics.clear();
			graphics.beginFill(_lineColor, 1.0);
			graphics.drawRect(_handleSize * -1, _handleSize * -1, _handleSize * 2, _handleSize * 2);
			graphics.beginFill(_fillColor, 1.0);
			graphics.drawRect((-1 * _handleSize) + _lineThickness, (-1 * _handleSize) + _lineThickness, (2 * _handleSize) - (2 * _lineThickness), (2 * _handleSize) - (2 * _lineThickness));
			graphics.endFill();
			
			// Draw the arrow
			graphics.lineStyle(_lineThickness/2, _lineColor);
			graphics.moveTo(_handleSize * 1.25, _handleSize * 1.25);
			graphics.lineTo(_handleSize * 1.8, _handleSize * 1.8);
			graphics.lineTo(_handleSize * 1.25, _handleSize * 1.7);
			graphics.moveTo(_handleSize * 1.8, _handleSize * 1.8);
			graphics.lineTo(_handleSize * 1.7, _handleSize * 1.25);
		}
	}			// end class definition
}				// end package definition