﻿package com.ryan.geom {
	import flash.display.Sprite;
	import flash.display.Graphics;
	
	public class RotateHandle extends TransformationHandle
	{		
		public function RotateHandle(lineColor:uint, lineThickness:Number, fillColor:uint, handleSize:Number, usehandCursor:Boolean=true)
		{
			var mode:uint=1;
			mode <<= MODE_ROTATE;
			super(lineColor, lineThickness, fillColor, handleSize, mode, usehandCursor);
		}
		
		override public function DrawHandle():void 
		{
			// Draw the basic shape (filled circle)
			graphics.clear();
			graphics.beginFill(_lineColor, 1.0);
			graphics.drawCircle(0, 0, _handleSize + _lineThickness);
			graphics.beginFill(_fillColor, 1.0);
			graphics.drawCircle(0, 0, _handleSize);
			graphics.endFill();

			// Arrow (ouroboros)
			graphics.lineStyle(_lineThickness, _lineColor);
			graphics.moveTo(0, -_handleSize - _lineThickness);
			graphics.lineTo(_handleSize * -0.25 - _lineThickness, _handleSize * -1.25 - _lineThickness);
			graphics.moveTo(0, -_handleSize - _lineThickness);
			graphics.lineTo(_handleSize * -0.25 - _lineThickness, _handleSize * -0.75 + _lineThickness);
		}
	}			// end class definition
}				// end package definition