﻿package com.ryan.geom {
	import flash.display.Sprite;
	import flash.display.Graphics;
	import flash.geom.Matrix;
	
	public class SkewHandle extends TransformationHandle
	{
		public function SkewHandle(lineColor:uint, lineThickness:Number, fillColor:uint, handleSize:Number, operationModeHorizontal:Boolean, usehandCursor:Boolean=true)
		{
			var mode:uint = 1;
			mode <<= (operationModeHorizontal ? MODE_SKEW_HORIZONTAL : MODE_SKEW_VERTICAL);
			super(lineColor, lineThickness, fillColor, handleSize, mode, usehandCursor);
		}
		
		override public function DrawHandle():void 
		{
			// Draw the basic shape (rectangle)
			graphics.clear();
			graphics.beginFill(_lineColor, 1.0);
			graphics.drawRect(-1 * _handleSize, -1 * _handleSize, 2 * _handleSize, 2 * _handleSize);
			graphics.beginFill(_fillColor, 1.0);
			graphics.drawRect((-1 * _handleSize) + _lineThickness, (-1 * _handleSize) + _lineThickness, (2 * _handleSize) - (2 * _lineThickness), (2 * _handleSize) - (2 * _lineThickness));
			graphics.endFill();
			// Skew it
			var skewMatrix = new Matrix(1, 0.3, 0, 1, 0, 0);
			this.transform.matrix = skewMatrix;
		}
	}			// end class definition
}				// end package definition