﻿package com.ryan.geom {
	import flash.display.Sprite;
	import flash.display.Graphics;
	//import flash.
	
	public class TransformationHandle extends Sprite
	{
		protected var _fillColor:uint = 0xFFFFFF;
		protected var _lineColor:uint = 0x0000FF;
		protected var _lineThickness:Number = 1;
		protected var _handleSize:Number = 1;
		protected var _operationMode:int;
		public function get OperationMode():int { return _operationMode; }
		public static const MODE_ROTATE:int = 0;
		public static const MODE_TRANSLATE:int = 1;
		public static const MODE_RECENTER:int = 2;
		public static const MODE_SKEW_VERTICAL:int = 3;
		public static const MODE_SKEW_HORIZONTAL:int = 4;
		public static const MODE_SCALE_VERTICAL:int = 5;
		public static const MODE_SCALE_HORIZONTAL:int = 6;
		public static const MODE_RESIZE:int = 7;
		
		public function CheckOperationMode(checkMode:int):Boolean {
			return ((_operationMode >> checkMode) & 1) == 1;
		}
		
		public function get OperationMode_Rotate():Boolean { 
			return CheckOperationMode(MODE_ROTATE);
		}
		
		public function get OperationMode_Translate():Boolean { 
			return CheckOperationMode(MODE_TRANSLATE);
		}
		
		public function get OperationMode_Recenter():Boolean { 
			return CheckOperationMode(MODE_RECENTER);
		}
		
		public function get OperationMode_Skew_Vertical():Boolean { 
			return CheckOperationMode(MODE_SKEW_VERTICAL);
		}
		
		public function get OperationMode_Skew_Horizontal():Boolean { 
			return CheckOperationMode(MODE_SKEW_HORIZONTAL);
		}
		
		public function get OperationMode_Scale_Vertical():Boolean { 
			return CheckOperationMode(MODE_SCALE_VERTICAL);
		}
		
		public function get OperationMode_Scale_Horizontal():Boolean { 
			return CheckOperationMode(MODE_SCALE_HORIZONTAL);
		}
		
		public function get OperationMode_Resize():Boolean { 
			return CheckOperationMode(MODE_RESIZE);
		}
		
		public function TransformationHandle(lineColor:uint, lineThickness:Number, fillColor:uint, handleSize:Number, operationMode:int=0, usehandCursor:Boolean=true)
		{
			_operationMode = operationMode;
			_fillColor = fillColor;
			_lineColor = lineColor;
			_lineThickness = lineThickness;
			_handleSize = handleSize;
			this.useHandCursor = usehandCursor;
		}
		
		public function DrawHandle():void 
		{
			// Draw the basic shape (filled circle)
			graphics.clear();
			graphics.beginFill(_lineColor, 1.0);
			graphics.drawCircle(0, 0, _handleSize + _lineThickness);
			graphics.beginFill(_fillColor, 1.0);
			graphics.drawCircle(0, 0, _handleSize);
			graphics.endFill();
		}
	}			// end class definition
}				// end package definition